/*
 * ICESOFT COMMERCIAL SOURCE CODE LICENSE V 1.1
 *
 * The contents of this file are subject to the ICEsoft Commercial Source
 * Code License Agreement V1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of the
 * License at
 * http://www.icesoft.com/license/commercial-source-v1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under
 * the License.
 *
 * Copyright 2009-2013 ICEsoft Technologies Canada, Corp. All Rights Reserved.
 */

package com.icesoft.icepush;

import org.icepush.*;
import org.icepush.http.Server;
import org.icepush.util.Slot;

import javax.servlet.ServletContext;
import java.util.Timer;

public class BrowserBoundServlet extends org.icepush.servlet.BrowserBoundServlet {

    public BrowserBoundServlet(PushContext pushContext, ServletContext context, PushGroupManager pushGroupManager, Timer monitoringScheduler, Configuration configuration, boolean terminateBlockingConnectionOnShutdown) {
        super(pushContext, context, pushGroupManager, monitoringScheduler, configuration, terminateBlockingConnectionOnShutdown);
    }

    protected Server createBlockingConnectionServer() {
        Slot heartbeatInterval = new Slot(configuration.getAttributeAsLong("heartbeatTimeout", 15000));
        Slot sequenceNo = new Slot(0);
        return new ConfigurationServer(pushContext, context, configuration,
                new AdjustHeartbeatServer(sequenceNo, heartbeatInterval, configuration,
                        new SequenceTaggingServer(sequenceNo,
                                new BlockingConnectionServer(pushGroupManager, monitoringScheduler, heartbeatInterval, terminateBlockingConnectionOnShutdown, configuration))));
    }
}
